
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */


var tunerUsed = false;						// false if we dont use any, "eyetv", "formac", "thetube" or "zattoo" otherwise
var tunerSoftwareNames = { eyetv:"EyeTV", formac:"FormacDVB", thetube:"TheTube", zattoo:"Zattoo" }
var tvAppName = "EyeTV";

var tunerChannels;
var tunerIsCurrentlyPlaying = null;			// holds the currently playing channel, null if none is playing
var tunerChannelsAssignedFor = '';			// holds the tuner key to which our channels were assigned



function tunerIsRunning() {
	if(!tunerUsed)
		return false;
	
	return FernsehPlugin.tunerIsRunning() == "1";
}


// returns the ID of the currently playing channel in the tv-software
function currentStation()
{
	if (!tunerIsRunning()) return null;
	
	var currStation = FernsehPlugin.currentTunerStation();
	for(var channel in availableChannels) {
		if(availableChannels[channel].getTuner() == currStation) {
			return channel;
		}
	}
	return null;
}


// call when switching the channel by clicking the button
function switchTVToChannel(showid) {
	if(showid && showHash[showid]) {
		var show = showHash[showid];
		show.drawCanvas('switchingChannel');
		
		if (!tunerIsRunning())
		{
			asTell("activate");
			setTimeout("switchTVToChannel(\"" + showid + "\");", 1000);
			return;
		}
		
		// revert indicator for old channel
		if (tunerIsCurrentlyPlaying)
		{
			var oldcanvas = getObj("tunerCanvas_" + tunerIsCurrentlyPlaying);
			if(oldcanvas && oldcanvas.lang && showHash[oldcanvas.lang])
			{
				tunerIsCurrentlyPlaying = null;
				showHash[oldcanvas.lang].drawCanvas();
			}
		}
		tunerIsCurrentlyPlaying = showHash[showid].channel;
		
		// finally switch the channel
		if(availableChannels[showHash[showid].channel])
		{
			directlySwitchTVToChannel(availableChannels[showHash[showid].channel].getTuner());
			setTimeout("showHash['" + showid + "'].drawCanvas()", 250);				// the widget is so lightning fast, we need this timeout =D
		}
	}
}


// switches the channel without telling the widget it did so. How mean!
function directlySwitchTVToChannel(channel)
{
	var AS_tell = '';
	
	if ('formac' == tunerUsed)
	{
		var formacChannels = getTunerChannels();
		var channelIndex = indexOfObjectInArray(formacChannels, channel);
		if (-1 != channelIndex) AS_tell = "set channel Index of first formacDVBTuner of first document to " + channelIndex;
	} else if ('thetube' == tunerUsed) {
		var ttChannels = getTunerChannels();
		var channelIndex = indexOfObjectInArray(ttChannels, channel);
		AS_tell = "select (channel "+(channelIndex+1)+") of the first device";
	} else if ('zattoo' == tunerUsed) {
		// zattoo is a bit trickier
		
		var ttChannels = getTunerChannels();
		var channelIndex = (indexOfObjectInArray(ttChannels, channel))+1;
				
		if (FernsehPlugin) FernsehPlugin.appleScript('with timeout of 10 seconds\ntell application "System Events"\ntell process "' + tvAppName + '"\ntell window "' + (LANG == 'de' ? 'Sender' : 'Channels') + '"\ntell group 1\ntell group 1\ntell scroll area 1\ntell outline 1\nselect row ' + channelIndex + '\nend tell\nend tell\nend tell\nend tell\nend tell\nend tell\nend tell\n\nend timeout')
	}
	else AS_tell = "set the current channel to (the channel number of (the first channel whose name contains \"" + channel + "\"))";
	
	if(AS_tell) {
		asTell(AS_tell);
	}
}


// returns the index of a channel (where is this used??)
function indexOfStation(internalName)
{
	var tunerChannels = getTunerChannels();
	var eyetvChannelName = availableChannels[internalName].getTuner();
	return indexOfObjectInArray(tunerChannels, eyetvChannelName);
}


function startTunerAndSwitchToPrefs()
{
	if(!tunerUsed)
		return;
	
	getObj("tuner_start_hint").innerHTML = tunerSoftwareNames[tunerUsed] + ' ' + locStr("wird gestartet...");
	asTell("activate");

	var channelstest = getTunerChannels();
	if ((undefined == channelstest) || (channelstest.length == 0))
	{
		getObj("tuner_start_hint").innerHTML = locStr("Fehler beim Laden der Sender");
		return;
	}

	getObj("tuner_start_hint").innerHTML = locStr("Senderzuweisungen werden geladen...");
	switchToPrefSection("tuner");				// this calls "adjustTunerSupport() which checks if the channels are assigned and loads the assigns
}


// called when we toggle tuner support
function tunerSupportToggled(force_to) {
	var selectElem = getObj("useTunerSoftware");
	if(!selectElem) {
		alert("tunerSupportToggled(): selectElem was not found. Aborting.");
		return;
	}
	
	if(force_to) {
		tunerUsed = force_to;
		for(var i = 0; i < selectElem.options.length; i++) {
			if(selectElem.options[i].value == force_to) {
				selectElem.options[i].selected = true;
				break;
			}
		}
	}
	else {
		tunerUsed = selectElem.options[selectElem.selectedIndex].value;
	}
	
	// tell the plugin
	if(window.widget) {
		if('eyetv' == tunerUsed || 'formac' == tunerUsed || 'thetube' == tunerUsed || 'zattoo' == tunerUsed) {
			FernsehPlugin.enableTunerSoftware(tunerUsed);
			tvAppName = FernsehPlugin.appNameForTuner();
		}
		
		// turn off tuner support
		else {
			tvAppName = null;
		}
	}
	
	// alter some GUI parts and check if channels are matched
	if(tunerUsed) {
		getObj('tunerTabName').innerHTML = tunerSoftwareNames[tunerUsed];
		getObj('tuner_start_hint').innerHTML = tunerSoftwareNames[tunerUsed] +  ' ' + locStr("wird gestartet um Sender zuzuweisen");
	}
	
	setTimeout("adjustTunerSupport()", 10);			// also checks whether the channels are assigned
}


// enables/disables the possible tuner software checkboxes and displays/hides the hint-text
function adjustTunerSupport() {
	if(!window.widget)
		return;
	
	getObj("eyetvSupport").disabled = !FernsehPlugin.canUseTuner('eyetv');
	getObj("formacSupport").disabled = !FernsehPlugin.canUseTuner('formac');
	getObj("theTubeSupport").disabled = !FernsehPlugin.canUseTuner('thetube');
	getObj("zattooSupport").disabled = !FernsehPlugin.canUseTuner('zattoo');
	
	// the hint text
	if(window.widget && tunerUsed && FernsehPlugin.canUseTuner(tunerUsed)) {
		if(tunerIsRunning()) {
			tunerChannels = getTunerChannels();
			addAssignedChannelsToSelector('tuner_senderlist', 'tuner_senderlist');
			if(tunerUsed != tunerChannelsAssignedFor) {
				guessAllTunerChannels();
			}
			
			getObj('tuner_start_button').style.display = "none";
			getObj('tuner_not_started_warning').style.display = "none";
			getObj('tuner_start_hint').style.display = "none";
			
			getObj('tuner_senderlist_parent').style.display = "block";
		}
		
		// tuner not running
		else {
			getObj('tuner_start_button').style.display = "block";
			getObj('tuner_not_started_warning').style.display = "block";
			getObj('tuner_not_started_warning').innerHTML = tunerChannelsAssigned() ? locStr("Sender sind bereits zugewiesen") : locStr("Sender sind nicht zugewiesen");
			getObj('tuner_start_hint').style.display = "block";
			
			getObj('tuner_senderlist_parent').style.display = "none";
			
		}
	}
	
	// don't use tuner software
	else {
		getObj('tuner_start_button').style.display = "none";
		getObj('tuner_not_started_warning').style.display = "none";
		getObj('tuner_start_hint').style.display = "none";
		
		getObj('tuner_senderlist_parent').style.display = "none";
	}
}





/*
 *********************************
 *  Assign TV software channels  *
 *********************************
 */

// returns a bool whether tuner-channels have been assigned
function tunerChannelsAssigned() {
	if(tunerUsed == tunerChannelsAssignedFor) {
		for(var c in availableChannels) {
			if(availableChannels[c].getTuner())
				return true;
		}
	}
	return false;
}


// loads the assigned channels from the prefs
function assignTunerChannels() {
	if(window.widget) {
		optvalue = widget.preferenceForKey("assignedTunerChannels");
		
		if(optvalue) {
			var tmpChannels = optvalue.split("////");
			
			for(i = 0; i < tmpChannels.length; i++) {
				if(tmpChannels[i]) {
					var tmpArray = tmpChannels[i].split(">>>>");
					
					if(availableChannels[tmpArray[0]]) {
						availableChannels[tmpArray[0]].setTuner(tmpArray[1]);
					}
				}
			}
		}
	}
}


// saves assigns
function saveTunerChannelAssigns() {
	if(tunerUsed) {
		var serChannels = '';
		
		for(var i in availableChannels) {
			var tuner = availableChannels[i].getTuner();
			if(tuner) {
				serChannels += i + ">>>>" + tuner + "////";
			}
		}
		
		// save to disk
		if(window.widget) {
			widget.setPreferenceForKey(serChannels, "assignedTunerChannels");
		}
		setChannelNamesInPlugin();
		tunerChannelsAssignedFor = tunerUsed;
	}
}


// create the select-menu for the clicked select element
function createTunerAssignMenu(selector) {
	if(!selector)
		return;
	
	// maybe the old menu did NOT get removed (onchange did not get called)
	if(selector.options.length > 1)
		return;
	
	// empty old menu
	while(selector.lastChild) {
		selector.removeChild(selector.lastChild);
	}
	
	// create a list of all channels
	var sel1 = document.createElement("option");
	sel1.setAttribute('value', '');
	sel1.innerHTML = locStr("lade Sender...");			// will be changed after we're done loading
	var sel2 = document.createElement("option");
	sel2.setAttribute('value', '');
	sel2.innerHTML = locStr("Kein Sender");
	
	selector.appendChild(sel1)
	selector.appendChild(document.createElement(has1043Features() ? 'hr' : 'option'));
	selector.appendChild(sel2);
	selector.appendChild(document.createElement(has1043Features() ? 'hr' : 'option'));
	
	// add all Tuner-channels
	for(i = 0; i < tunerChannels.length; i++) {
		var name = tunerChannels[i];
		var elem = document.createElement("option");
		elem.value = name;
		elem.innerHTML = name ? name : locStr("unbenannter Sender");
		
		if(availableChannels[selector.lang].getTuner() && (availableChannels[selector.lang].getTuner() == tunerChannels[i])) {
			elem.selected = true;
		}
		
		selector.appendChild(elem);
	}
	
	// clean up
	selector.options[0].innerHTML = locStr("zuweisen...");
	selector.setAttribute("onchange", "removeTunerAssignMenu(this)");
}


// cleans given selector
function removeTunerAssignMenu(selector) {
	if(!selector || (selector.length < 2))
		return;
	
	var this_selectedIndex = selector.selectedIndex;
	var selected_name = selector.options[this_selectedIndex].value;
	if(availableChannels[selector.lang]) {
		availableChannels[selector.lang].setTuner(selected_name);
	}
	
	// remove all options but remember the selected one
	while(selector.lastChild) {
		selector.removeChild(selector.lastChild);
	}
	
	// add again one element to choose "reassign channels"
	var element = document.createElement("option");
	element.value = selected_name;
	element.lang = this_selectedIndex;
	element.innerHTML = selected_name ? selected_name : locStr("zuweisen...");
	element.selected = true;
	
	selector.appendChild(element);
	selector.setAttribute("onmousedown", "createTunerAssignMenu(this)");
}


// returns an array containing all channels the tuner software offers
function getTunerChannels()
{
	if (('formac' == tunerUsed) || ('thetube' == tunerUsed) || ('zattoo' == tunerUsed))
	{
		// Formac is a little... well
		// it doesn't return channels until it has fully launched
		var counter = 0;
		var channels = FernsehPlugin.tunerChannels();
		while (undefined == channels)
		{
			channels = FernsehPlugin.tunerChannels();
			if (counter++ == 1000) return undefined;
		}
		return channels;
		//return FernsehPlugin.formacChannels();
	}
	else {
		return FernsehPlugin.tunerChannels();
	}
}


// automatically allocates the channels to the tuners: for every available channel (widget) guess an available channel (tuner)
function guessAllTunerChannels() {
	var tunerChannelPool = new Array();
	var origTunerChannelNames = new Object();
	
	// all tuner channel names should be lowercase and not to contain spaces for performance reasons!
	for(var i = 0; i < tunerChannels.length; i++) {
		var foo = tunerChannels[i].toLowerCase();
		foo = foo.replace(/ /g, "");
		tunerChannelPool.push(foo);
		origTunerChannelNames[foo] = tunerChannels[i];
	}
	
	// loop widget channels to find a match
	for(var c in availableChannels) {
		availableChannels[c].setTuner(null);
		
		var chan_id = availableChannels[c].getID();
		var our_select = getObj("tuner_assign_" + chan_id);
		if(our_select) {
			var guessedTuner = guessTunerForChannel(tunerChannelPool, availableChannels[c].getGuessChannelNames());
			//alert("guessedTuner for " + availableChannels[c].getName() + " is " + guessedTuner);
			
			if(guessedTuner != -1) {
				var guessedTunerName = origTunerChannelNames[guessedTuner];
				our_select.options[0].value = guessedTunerName;
				our_select.options[0].innerHTML = guessedTunerName;
				
				availableChannels[c].setTuner(guessedTunerName);
			}
		}
	}
	
	tunerChannelsAssignedFor = tunerUsed;
}


// guesses from an array "channels" the most likely match for any name in the array "chan"
function guessTunerForChannel(channels, chan)
{
	// FIRST try - see if the name matches exactly
	for(var i = 0; i < channels.length; i++) {
		if(inArray(channels[i], chan)) {
			return channels[i];
		}
	}
	
	// SECOND and THIRD try - count letters in consecutive order
	var bestMatch = -1;
	var bestNumMatches = 0;
	
	for(var i = 0; i < chan.length; i++) {
		var widgetChan = chan[i];
		
		for(var k = 0; k < channels.length; k++) {
			var tunerChan = channels[k];
			var numMatches = 0;
			var string1index = 0;
			var string2index = 0;
			
			// look for best substring matches of widgetChan in tunerChan
			while((string1index < tunerChan.length) && (string2index < widgetChan.length)) {
				if(numMatches > 0) {
					string2index++;
				}
				
				// look for a matching char
				if(tunerChan.substr(string1index++, 1) == widgetChan.substr(string2index, 1)) {
					numMatches++;
				}
			}
			
			// remember best match
			if (numMatches > bestNumMatches)
			{
				bestMatch = tunerChan;
				bestNumMatches = numMatches;
			}
			
			var numMatches = 0;
			var string1index = 0;
			var string2index = 0;
			
			// look for best substring matches of tunerChan in widgetChan (reverse from earlier loop)
			while((string1index < tunerChan.length) && (string2index < widgetChan.length)) {
				if(numMatches > 0) {
					string1index++;
				}
				
				// look for a matching char
				if(tunerChan.substr(string1index, 1) == widgetChan.substr(string2index++, 1)) {
					numMatches++;
				}
			}
			
			// remember best match
			if (numMatches > bestNumMatches)
			{
				bestMatch = tunerChan;
				bestNumMatches = numMatches;
			}
		}
	}
	
	return (bestNumMatches >= 3) ? bestMatch : -1;
}



function tunerSupportsRecording(tuner_key) {
	switch(tuner_key) {
		case 'eyetv':
		case 'formac':		return true;
	}
	return false;
}


function toggleRecordingTimer(showid) {
	if(showid && showHash[showid]) {
		showHash[showid].toggleRecordingTimer()
	}
}


function deleteRecordTimerForShow(channel, showname, showlength, timestamp)
{
	if (!tunerIsRunning())
	{
		asTell("activate");
		setTimeout("deleteRecordTimerForShow(\""+channel+"\",\""+showname+"\",\""+showlength+"\",\""+timestamp+"\");", 2000);
		return false;
	}

	if (tunerUsed == 'formac')
	{
		// later on, do something here
		var date = new Date();
		date.setTime(timestamp);
		var ourDateString = date.toLocaleString();
		
		FernsehPlugin.appleScript("set aStartDateStr to \"" + ourDateString + "\"\nset mDateStart to date aStartDateStr\ntell application\"" + tvAppName + "\"\nactivate\nset aDoc to first document\nset aChan to first formacDVBTuner of aDoc\nset RemoveScheduledEntry of aChan to mDateStart\nend tell");
	} else if (tunerUsed == 'eyetv') {
		var recordID = FernsehPlugin.recordingUniqueIDForChannel(channel, ""+timestamp);
		if (undefined == recordID)
		{
			alert("Ouch, couldn't find Unique ID for show. Sorry.");
			return false;
		}
			
		asTell("delete (every program whose unique ID is " + recordID + ")");
	} else if (tunerUsed == 'thetube') {
		return false;
	} else if (tunerUsed = 'zattoo')
	{
		// well, duh, how's zattoo supposed to tape a show?
		return false;
	}
	
	FernsehPlugin.recacheScheduledShows();
	return true;
}

function setRecordTimerForShow(channel, showname, showlength, timestamp)
{	
	var date = new Date();
	date.setTime(timestamp);

	var ourDateString = date.toLocaleString();
	
	if (tunerUsed == 'formac')
	{
		var endTime = ((Math.abs(showlength) * 60000) + timestamp);
		var endDate = new Date();
		endDate.setTime(endTime);
		var recChannel = channel;
		var formacChannels = getTunerChannels();
		var channelIndex = indexOfObjectInArray(formacChannels, recChannel);
		if (-1 != channelIndex) FernsehPlugin.appleScript("set aChannelIndex to \"" + (channelIndex+1) + "\"\nset aMovieName to \"" + showname.replace(/"/g, "\\\"") + "\"\nset aStartDateStr to \"" + ourDateString + "\"\nset aStopDateStr to \"" + endDate.toLocaleString() + "\"\nset mDateStart to date aStartDateStr\nset mDateStop to date aStopDateStr\ntell application \"" + tvAppName + "\"\nactivate\nset aDoc to first document\nset aChan to first formacDVBTuner of aDoc\nset channelList to channel List of aChan\nset aChannelName to item aChannelIndex of channelList\nset theRecChunk to {aChannelName, aMovieName, mDateStart, mDateStop}\nset video Dimension of aChan to 1.0\nset InsertScheduleEntry of aChan to theRecChunk\nend tell\n");
	} else if (tunerUsed == 'eyetv') {
		// EyeTV
		prog = new eyeTVSchedule();
		prog.starttime = ourDateString;
		prog.duration = (Math.abs(showlength) * 60);
		prog.stationname = channel;
		prog.title = showname.replace(/"/g, "\\\"");
		prog.createSchedule();
	} else if (tunerUsed == 'thetube') {
		return false;
	} else if (tunerUsed == 'zattoo')
	{
		return false;
	}
	
	FernsehPlugin.recacheScheduledShows();
	return true;
}





// Applescript wrappers, partially copy & paste from Elgato sample code
var kMissingValueString = "missing value"; // string constant returned, if an AppleScript didn't succeed.

// Send a command to Application
function asTell(command) {
	if (FernsehPlugin) FernsehPlugin.appleScript('with timeout of 10 seconds\ntell application "' + tvAppName + '"\n try\n' + command + '\n on error\n return "' + kMissingValueString + '"\n end try\n end tell\n\nend timeout');
}

function eyeTVSchedule() {
	this.starttime = "";
	this.duration = 30;
	this.title = "Untitled";
	this.stationname = "";
	
	this.createSchedule = function() {
		cmd = 'make new program with properties {start time:date "' +
				this.starttime + '", duration:' + 
				this.duration + ', title:"' + 
				this.title + 
				'", channel number:(the channel number of (the first channel whose name contains "' + this.stationname + '")) as integer' +
				'}';
		asTell(cmd);
	}	
}

